function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import React from "/apps/websight-atlaskit-esm/web-resources/react.js";
import { Profile as AtlaskitProfile } from "/apps/websight-atlaskit-esm/web-resources/@atlaskit/atlassian-navigation.js";
import Popup from "/apps/websight-atlaskit-esm/web-resources/@atlaskit/popup.js";
import { LinkItem, MenuGroup, Section } from "/apps/websight-atlaskit-esm/web-resources/@atlaskit/menu.js";
import Modal, { ModalTransition } from "/apps/websight-atlaskit-esm/web-resources/@atlaskit/modal-dialog.js";
import Tooltip from "/apps/websight-atlaskit-esm/web-resources/@atlaskit/tooltip.js";
import styled from "/apps/websight-atlaskit-esm/web-resources/styled-components.js";
import authContextAware from "/apps/websight-rest-atlaskit-client/web-resources/js/AuthContextAware.js";
import LoginForm from "./LoginForm.js";
import AuthContextProvider, { AUTH_CONTEXT_UPDATED } from "/apps/websight-rest-esm-client/web-resources/AuthContextProvider.js";
const Icon = styled.i`
    border-radius: 50%;
    width: 24px;
    height: 24px;
`;
const FormContainer = styled.div`
    padding: 20px 30px;

    input {
        width: 250px;
    }
`;

class Profile extends React.Component {
  constructor(props) {
    super(props);
    this.state = {
      isOpenForLogIn: false,
      isOpenForProfile: false,
      isOpenModal: false
    };
    this.profileMenu = this.profileMenu.bind(this);
  }

  componentDidMount() {
    window.addEventListener(AUTH_CONTEXT_UPDATED, e => {
      if (e.detail.authContext.userId === 'anonymous') {
        this.setState({
          isOpenModal: true,
          isOpenForLogIn: false
        });
      } else {
        this.setState({
          isOpenModal: false
        });
      }
    });
  }

  loginFormContainer() {
    return /*#__PURE__*/React.createElement(FormContainer, null, /*#__PURE__*/React.createElement(LoginForm, {
      asyncSubmit: true
    }));
  }

  profileMenu() {
    const onFinish = () => this.setState({
      isOpenForProfile: false,
      isOpenForLogIn: false
    });

    const asyncFormLogout = () => fetch('/system/sling/logout', {
      method: 'GET',
      redirect: 'manual'
    }).then(() => {
      AuthContextProvider.checkAuthentication(onFinish, onFinish);
    });

    return /*#__PURE__*/React.createElement(MenuGroup, null, /*#__PURE__*/React.createElement(Section, {
      hasSeparator: true
    }, /*#__PURE__*/React.createElement(LinkItem, {
      onClick: asyncFormLogout
    }, "Log out")));
  }

  render() {
    const {
      isOpenForProfile,
      isOpenForLogIn,
      isOpenModal
    } = this.state;
    const {
      authContext
    } = this.props;

    if (!authContext.isInitialized()) {
      return /*#__PURE__*/React.createElement(React.Fragment, null);
    } else {
      return authContext.isLoggedIn() ? /*#__PURE__*/React.createElement(Popup, {
        content: this.profileMenu,
        isOpen: isOpenForProfile,
        placement: "bottom-start",
        onClose: () => this.setState({
          isOpenForProfile: false
        }),
        trigger: triggerProps => /*#__PURE__*/React.createElement(AtlaskitProfile, _extends({}, triggerProps, {
          icon: /*#__PURE__*/React.createElement(Tooltip, {
            hideTooltipOnClick: true,
            content: 'Logged in as ' + authContext.userId
          }, /*#__PURE__*/React.createElement(Icon, {
            className: "material-icons"
          }, "account_circle")),
          onClick: () => this.setState(prevState => ({
            isOpenForProfile: !prevState.isOpenForProfile
          })),
          isSelected: isOpenForProfile
        }))
      }) : /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(ModalTransition, null, isOpenModal && /*#__PURE__*/React.createElement(Modal, {
        actions: [{
          text: 'Close',
          onClick: () => this.setState({
            isOpenModal: false
          })
        }],
        heading: "You have been logged out"
      }, "Your session has been terminated. Log in again or continue as anonymous user.")), /*#__PURE__*/React.createElement(Popup, {
        content: this.loginFormContainer,
        isOpen: isOpenForLogIn,
        placement: "bottom-start",
        onClose: () => this.setState({
          isOpenForLogIn: false
        }),
        trigger: triggerProps => /*#__PURE__*/React.createElement(AtlaskitProfile, _extends({}, triggerProps, {
          icon: /*#__PURE__*/React.createElement(Icon, {
            className: "material-icons"
          }, "login"),
          onClick: () => this.setState(prevState => ({
            isOpenForLogIn: !prevState.isOpenForLogIn
          })),
          isSelected: isOpenForLogIn
        }))
      }));
    }
  }

}

export default authContextAware(Profile);