import React from "/apps/websight-atlaskit-esm/web-resources/react.js";
import { IntlProvider } from "/apps/websight-atlaskit-esm/web-resources/react-intl.js";
import { AkCode, AkCodeBlock } from "/apps/websight-atlaskit-esm/web-resources/@atlaskit/code.js";
import { RightSidePanel } from "/apps/websight-atlaskit-esm/web-resources/@atlaskit/right-side-panel.js";
import SectionMessage from "/apps/websight-atlaskit-esm/web-resources/@atlaskit/section-message.js";
import styled from "/apps/websight-atlaskit-esm/web-resources/styled-components.js";
import Help from "/apps/websight-atlaskit-esm/web-resources/@atlaskit/help.js";
import { GlobalStyle } from "/apps/websight-admin/web-resources/GlobalStyle.js";
const HelpArticleContainer = styled.div`
    margin-bottom: 40px;
    padding: 20px;
`;
const HelpArticleTitleContainer = styled.h2`
    margin-bottom: 15px;
`;
const MethodLiPointContainer = styled.div`
    margin-bottom: 15px;
`;
const MethodExampleContainer = styled.div`
    margin-top: 10px;
`;
const listStyle = {
  marginTop: '6px',
  paddingLeft: '30px'
};

const TextCode = props => /*#__PURE__*/React.createElement(AkCode, {
  language: "text",
  text: props.text
});

export default class Helper extends React.Component {
  constructor(props) {
    super(props);
    this.state = {
      isOpen: false
    };
    this.open = this.open.bind(this);
    this.close = this.close.bind(this);
  }

  open() {
    this.setState(prevState => ({
      isOpen: !prevState.isOpen
    }));
  }

  close() {
    this.setState({
      isOpen: false
    });
  }

  render() {
    const {
      isOpen
    } = this.state;
    return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(GlobalStyle, {
      styles: `
                    .helper-container--open + div {
                        flex: 0 0 500px !important;
                        width: 500px !important;
                    }
                    .helper-container--open + div > div {
                        width: 500px;
                    }
                `
    }), /*#__PURE__*/React.createElement("div", {
      className: `helper-container ${isOpen ? 'helper-container--open' : ''}`
    }, /*#__PURE__*/React.createElement(RightSidePanel, {
      isOpen: isOpen,
      attachPanelTo: "groovy-container",
      onOpenAnimationFinished: this.props.onAnimationFinished,
      onCloseAnimationFinished: this.props.onAnimationFinished
    }, /*#__PURE__*/React.createElement(IntlProvider, {
      locale: "en"
    }, /*#__PURE__*/React.createElement(Help, {
      onButtonCloseClick: this.close,
      footer: /*#__PURE__*/React.createElement("span", null, "Footer")
    }, /*#__PURE__*/React.createElement(HelpArticleContainer, null, /*#__PURE__*/React.createElement(HelpArticleTitleContainer, null, "Bindings"), /*#__PURE__*/React.createElement("p", null, "All of the binding variables listed below are ready to use in a Groovy script:", /*#__PURE__*/React.createElement("ul", {
      style: listStyle
    }, [/*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(TextCode, {
      text: "data"
    }), " - if provided data string is valid JSON then ", /*#__PURE__*/React.createElement(TextCode, {
      text: "data"
    }), " is a ", /*#__PURE__*/React.createElement(TextCode, {
      text: "java.util.Map"
    }), " object, otherwise it is available as a ", /*#__PURE__*/React.createElement(TextCode, {
      text: "String"
    })), /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(TextCode, {
      text: "bundleContext"
    }), " - ", /*#__PURE__*/React.createElement(TextCode, {
      text: "org.osgi.framework.BundleContext"
    })), /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(TextCode, {
      text: "resourceResolver"
    }), " - ", /*#__PURE__*/React.createElement(TextCode, {
      text: "org.apache.sling.api.resource.ResourceResolver"
    })), /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(TextCode, {
      text: "session"
    }), " - ", /*#__PURE__*/React.createElement(TextCode, {
      text: "javax.jcr.Session"
    })), /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(TextCode, {
      text: "request"
    }), " - ", /*#__PURE__*/React.createElement(TextCode, {
      text: "org.apache.sling.api.SlingHttpServletRequest"
    })), /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(TextCode, {
      text: "out"
    }), " - ", /*#__PURE__*/React.createElement(TextCode, {
      text: "java.io.StringWriter"
    })), /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(TextCode, {
      text: "log"
    }), " - ", /*#__PURE__*/React.createElement(TextCode, {
      text: "org.slf4j.Logger"
    }))].map(line => /*#__PURE__*/React.createElement("li", {
      key: `helper-variable-${line}`
    }, line)))), /*#__PURE__*/React.createElement(HelpArticleTitleContainer, null, "Imports"), /*#__PURE__*/React.createElement("p", null, "List of packages imported automatically into all scripts:", /*#__PURE__*/React.createElement("ul", {
      style: listStyle
    }, ['javax.jcr', 'org.apache.sling.api', 'org.apache.sling.api.resource'].map(line => /*#__PURE__*/React.createElement("li", {
      key: `helper-package-${line}`
    }, /*#__PURE__*/React.createElement(TextCode, {
      text: line
    })))), /*#__PURE__*/React.createElement("br", null), /*#__PURE__*/React.createElement(SectionMessage, {
      appearance: "info"
    }, "Pre-imported packages or individual classes can be configured via OSGi configuration (Groovy Console Compiler Configuration Service).")), /*#__PURE__*/React.createElement(HelpArticleTitleContainer, null, "Methods"), /*#__PURE__*/React.createElement("p", null, "List of methods available for use in all scripts:", /*#__PURE__*/React.createElement("ul", {
      style: listStyle
    }, [{
      method: 'getNode(String path)',
      description: /*#__PURE__*/React.createElement(React.Fragment, null, "Returns the ", /*#__PURE__*/React.createElement(TextCode, {
        text: "javax.jcr.Node"
      }), " for a specified absolute path. Throws ", /*#__PURE__*/React.createElement(TextCode, {
        text: "javax.jcr.PathNotFoundException"
      }), " if it does not exist, or ", /*#__PURE__*/React.createElement(TextCode, {
        text: "javax.jcr.RepositoryException"
      }), " if other error occurs.")
    }, {
      method: 'getResource(String path)',
      description: /*#__PURE__*/React.createElement(React.Fragment, null, "Returns the ", /*#__PURE__*/React.createElement(TextCode, {
        text: "org.apache.sling.api.resource.Resource"
      }), " for a given path.")
    }, {
      method: 'recursive(Node node, Closure closure)',
      description: /*#__PURE__*/React.createElement(React.Fragment, null, "Provides a simple way to traverse through all the children of a given ", /*#__PURE__*/React.createElement(TextCode, {
        text: "javax.jcr.Node"
      }), "."),
      example: 'Node contentNode = getNode("/content") \nrecursive(contentNode) { node -> \n    println node.getPath() \n}'
    }, {
      method: 'recursive(Resource resource, Closure closure)',
      description: /*#__PURE__*/React.createElement(React.Fragment, null, "Provides a simple way to traverse through all the children of a given ", /*#__PURE__*/React.createElement(TextCode, {
        text: "org.apache.sling.api.resource.Resource"
      }), "."),
      example: 'Resource contentResource = getResource("/content") \nrecursive(contentResource) { resource -> \n    println resource.getPath() \n}'
    }, {
      method: 'move(String source, String destination)',
      description: 'Moves a node from a given source to provided destination. Please note that session is automatically saved after move.'
    }, {
      method: 'rename(Node node, String newName)',
      description: /*#__PURE__*/React.createElement(React.Fragment, null, "Changes the name of given ", /*#__PURE__*/React.createElement(TextCode, {
        text: "javax.jcr.Node"
      }), " to the ", /*#__PURE__*/React.createElement(TextCode, {
        text: "newName"
      }), ". Please note that session is automatically saved after rename.")
    }, {
      method: 'copy(String source, String destination)',
      description: /*#__PURE__*/React.createElement(React.Fragment, null, "Copies ", /*#__PURE__*/React.createElement(TextCode, {
        text: "javax.jcr.Node"
      }), " from a ", /*#__PURE__*/React.createElement(TextCode, {
        text: "source"
      }), " path to a given ", /*#__PURE__*/React.createElement(TextCode, {
        text: "destination"
      }), " path.")
    }, {
      method: 'save()',
      description: 'Saves the current session.'
    }, {
      method: 'getModel(String path, Class type)',
      description: /*#__PURE__*/React.createElement(React.Fragment, null, "Instantiates the given Sling Model for the resource from a given ", /*#__PURE__*/React.createElement(TextCode, {
        text: "path"
      }), ".")
    }, {
      method: 'getService(Class type)',
      description: /*#__PURE__*/React.createElement(React.Fragment, null, "Returns a service that implements and is registered under the given ", /*#__PURE__*/React.createElement(TextCode, {
        text: "type"
      }), ".")
    }, {
      method: 'getService(String className)',
      description: /*#__PURE__*/React.createElement(React.Fragment, null, "Returns a service that implements and is registered under the given ", /*#__PURE__*/React.createElement(TextCode, {
        text: "className"
      }), ".")
    }, {
      method: 'getServices(Class type, String filter)',
      description: /*#__PURE__*/React.createElement(React.Fragment, null, "Returns a list of services that implement and are registered under the given ", /*#__PURE__*/React.createElement(TextCode, {
        text: "type"
      }), " and match the specified ", /*#__PURE__*/React.createElement(TextCode, {
        text: "filter"
      }), " expression.")
    }, {
      method: 'getServices(String className, String filter)',
      description: /*#__PURE__*/React.createElement(React.Fragment, null, "Returns a list of services that implement and are registered under the given ", /*#__PURE__*/React.createElement(TextCode, {
        text: "className"
      }), " and match the specified ", /*#__PURE__*/React.createElement(TextCode, {
        text: "filter"
      }), " expression.")
    }].map(line => /*#__PURE__*/React.createElement("li", {
      key: `helper-method-${line.method}`
    }, /*#__PURE__*/React.createElement(MethodLiPointContainer, null, /*#__PURE__*/React.createElement(AkCode, {
      language: "java",
      text: line.method
    }), /*#__PURE__*/React.createElement("div", null, line.description), line.example && /*#__PURE__*/React.createElement(MethodExampleContainer, null, "Example:", /*#__PURE__*/React.createElement(AkCodeBlock, {
      language: "java",
      text: line.example || '',
      showLineNumbers: false
    })))))), /*#__PURE__*/React.createElement("br", null), /*#__PURE__*/React.createElement(SectionMessage, {
      appearance: "info"
    }, "Service objects provided by above methods are automatically released from the bundle context after script execution."))))))));
  }

}