import React from "/apps/websight-atlaskit-esm/web-resources/react.js";
import styled from "/apps/websight-atlaskit-esm/web-resources/styled-components.js";
import TableTree, { Header, Headers, Rows } from "/apps/websight-atlaskit-esm/web-resources/@atlaskit/table-tree.js";
import { NoTableDataContainer } from "/apps/websight-admin/web-resources/Containers.js";
import { colors } from "/apps/websight-admin/web-resources/theme.js";
import { LoadingWrapper } from "/apps/websight-admin/web-resources/Wrappers.js";
import PackageRow from "./PackageRow.js";
const TableRowsContainer = styled.div`
    .name-cell span[class^="styled__ChevronContainer"] {
        height: 100%;
        top: 0;
    }
    
    div[class^="styled__TreeRowContainer"][aria-level="1"] {
        &:hover {
            background-color: ${colors.veryLightGrey};
        } 
    }
`;

const preparePackages = (packages, selectedPackagePath) => {
  return (packages || []).map(packageData => {
    const logs = packageData.logs || [];
    const children = logs.length > 0 ? [{
      logs: logs,
      path: packageData.path
    }] : [];
    return { ...packageData,
      id: packageData.path,
      // 'id' will be used as a 'key' in actual row in a table
      children: children,
      isSelectedPackage: packageData.path === selectedPackagePath
    };
  });
};

const loadingWrapperSpinnerStyle = {
  top: '30vh',
  bottom: 'auto'
};
export default class PackageTable extends React.Component {
  render() {
    return /*#__PURE__*/React.createElement(TableTree, null, /*#__PURE__*/React.createElement(Headers, null, /*#__PURE__*/React.createElement(Header, {
      width: 'calc(80% - 335px)'
    }, "Package"), /*#__PURE__*/React.createElement(Header, {
      width: '160px'
    }, "Status"), /*#__PURE__*/React.createElement(Header, {
      width: '20%'
    }, "Group"), /*#__PURE__*/React.createElement(Header, {
      width: '175px'
    }, "Actions")), /*#__PURE__*/React.createElement(LoadingWrapper, {
      isLoading: this.props.isLoading,
      spinnerStyle: loadingWrapperSpinnerStyle,
      spinnerSize: "large"
    }, /*#__PURE__*/React.createElement(TableRowsContainer, null, /*#__PURE__*/React.createElement(Rows, {
      items: preparePackages(this.props.packages, this.props.selectedPackagePath),
      render: entry => {
        return new PackageRow({
          data: entry,
          groups: this.props.groups,
          toggleConsole: this.props.toggleConsole,
          onConsoleScroll: this.props.onConsoleScroll,
          openConsoleForNewPackage: this.props.openConsoleForNewPackage,
          refreshPage: this.props.refreshPage,
          selectPackage: this.props.selectPackage,
          updateActionState: this.props.updateActionState,
          extraActions: this.props.extraActions
        }).render();
      }
    })), this.props.packages.length === 0 && this.props.isInitialized && /*#__PURE__*/React.createElement(NoTableDataContainer, null, /*#__PURE__*/React.createElement("h3", null, "No packages found."))));
  }

}