import React from "/apps/websight-atlaskit-esm/web-resources/react.js";
import { Checkbox } from "/apps/websight-atlaskit-esm/web-resources/@atlaskit/checkbox.js";
import ConfirmationModal from "/apps/websight-admin/web-resources/ConfirmationModal.js";
import { getExtension, persistIgnoredExtension } from "../../utils/ContentResourceUtil.js";
export default class UnknownFileTypeOpenConfirmationModal extends React.Component {
  constructor(props) {
    super(props);
    this.state = {
      resourceName: '',
      messageDisabled: false
    };
  }

  open(resource, callback) {
    this.setState({
      resourceName: resource.name,
      messageDisabled: false,
      callback: callback
    });
    this.confirmationModal.open();
  }

  close() {
    this.confirmationModal.close();
  }

  render() {
    const extension = getExtension(this.state.resourceName);
    return /*#__PURE__*/React.createElement(ConfirmationModal, {
      appearance: "warning",
      buttonText: "Open",
      heading: "Open resource",
      message: /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("div", null, "Are you sure you want to open ", /*#__PURE__*/React.createElement("b", null, this.state.resourceName), " in editor?", /*#__PURE__*/React.createElement("br", null), /*#__PURE__*/React.createElement("br", null)), extension && /*#__PURE__*/React.createElement(Checkbox, {
        label: `Don't show me this message again for .${extension} extension`,
        isChecked: this.state.messageDisabled,
        onChange: event => this.setState({
          messageDisabled: event.target.checked
        })
      })),
      onConfirm: () => {
        if (extension && this.state.messageDisabled) {
          persistIgnoredExtension(extension);
        }

        this.confirmationModal.close();
        this.state.callback && this.state.callback();
      },
      ref: element => this.confirmationModal = element
    });
  }

}