import React from "/apps/websight-atlaskit-esm/web-resources/react.js";
import Tooltip from "/apps/websight-atlaskit-esm/web-resources/@atlaskit/tooltip.js";
import AuthorizableInfoSection from "./AuthorizableInfoSection.js";
import AuthorizablesTags from "./AuthorizablesTags.js";
import { DetailsFieldContainer, DetailsLabelContainer, DetailsTagsContainer, SectionContainer, SectionsContainer, SectionsGroupContainer } from "./Containers.js";
export default class UserDetailsGeneral extends React.Component {
  render() {
    const {
      user
    } = this.props;
    const details = [{
      label: 'Full name',
      value: user.displayName
    }, {
      label: 'Email',
      value: user.email
    }, {
      label: 'Groups',
      value: (user.groups || []).length ? [/*#__PURE__*/React.createElement(DetailsTagsContainer, {
        key: "groups"
      }, /*#__PURE__*/React.createElement(AuthorizablesTags, {
        authorizables: user.groups,
        onePerLine: true
      }))] : []
    }];
    const statistics = [{
      label: 'Login count',
      value: user.loginCount
    }, {
      label: 'Last login',
      value: user.lastLoggedIn,
      tooltip: user.lastLoggedInRelative
    }];
    const detailsSection = /*#__PURE__*/React.createElement(SectionContainer, null, /*#__PURE__*/React.createElement("h4", null, "Details"), details.map(entry => (entry.value || []).length ? /*#__PURE__*/React.createElement(DetailsFieldContainer, null, /*#__PURE__*/React.createElement(DetailsLabelContainer, null, entry.label, ":"), entry.value) : ''));
    const statisticsSection = /*#__PURE__*/React.createElement(SectionContainer, null, /*#__PURE__*/React.createElement("h4", null, "Statistics"), statistics.map(entry => entry.value ? /*#__PURE__*/React.createElement(DetailsFieldContainer, null, /*#__PURE__*/React.createElement(DetailsLabelContainer, null, entry.label, ":"), entry.tooltip ? /*#__PURE__*/React.createElement(Tooltip, {
      content: entry.value,
      tag: "span"
    }, /*#__PURE__*/React.createElement("span", null, entry.tooltip)) : entry.value) : ''));
    return /*#__PURE__*/React.createElement(SectionsContainer, null, /*#__PURE__*/React.createElement(SectionsGroupContainer, null, /*#__PURE__*/React.createElement(AuthorizableInfoSection, {
      title: "User",
      authorizable: user
    }), detailsSection), statistics.map(x => x.value).filter(x => x).length ? statisticsSection : '');
  }

}