import React from "/apps/websight-atlaskit-esm/web-resources/react.js";
import styled from "/apps/websight-atlaskit-esm/web-resources/styled-components.js";
import BasicPermissions from "./BasicPermissions.js";
import AdvancedPermissions from "./AdvancedPermissions.js";
const PermissionsDetailsContainer = styled.div`
    display: block;
    width: 100%;
    margin-top: 10px;
`;
export default class PermissionsDetails extends React.Component {
  constructor(props) {
    super(props);
    this.state = {
      advancedView: false
    };
    this.onViewChange = this.onViewChange.bind(this);
  }

  onViewChange(isAdvanced) {
    this.setState({
      advancedView: isAdvanced
    });
  }

  render() {
    const {
      advancedView
    } = this.state;
    const {
      authorizableId
    } = this.props;
    return /*#__PURE__*/React.createElement(PermissionsDetailsContainer, null, !advancedView && /*#__PURE__*/React.createElement(BasicPermissions, {
      authorizableId: authorizableId,
      changeView: this.onViewChange
    }), advancedView && /*#__PURE__*/React.createElement(AdvancedPermissions, {
      authorizableId: authorizableId,
      changeView: this.onViewChange
    }));
  }

}